package medianRanking.Exemple;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import medianRanking.MedianRanking;
import annotations.*;

@MRAnnotation(description = "Classe présentant les annotations", name = "Exemple d'annotation")
public class ExampleAnnotation<T> implements MedianRanking<T> {

	@MRConstructorAnnotation
	public ExampleAnnotation(
			@MRParameterAnnotation(defaultValue = "1.0", description = "Paramètre du constructeur", name = "param") int param) {

	}

	@Override
	public List<Collection<T>> computMedianRanking(
			Collection<List<Collection<T>>> rankings) {
		return rankings.iterator().next();
	}

	@Override
	public Collection<List<Collection<T>>> computMedianRankings(
			Collection<List<Collection<T>>> rankings) {
		Collection<List<Collection<T>>> ret = new ArrayList<List<Collection<T>>>();
		ret.add(this.computMedianRanking(rankings));
		return ret;
	}

	@Override
	public String getFullName() {
		return "Ma classe d'exemple d'annotations";
	}

	@Override
	public boolean isBreakingTiesArbitrarily() {
		return true;
	}

	@Override
	public boolean isUsingRandomValue() {
		return false;
	}
}
