package annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Annotation s'appliquant à une classe implémentant Median Ranking
 * 
 * @author adrien
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface MRAnnotation {
	
	/**
	 * Nom de la classe
	 */
	String name();	
	
	/**
	 * Description de l'algorithme
	 */
	String description();
	
	/**
	 * Cache une classe
	 */
	boolean hide() default false;
	
	/**
	 * Package virtuel
	 */
	String virtualPackage() default "";
}
