package annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Annotation pour un constructeur de MedianRanking
 * 
 * @author adrien
 * 
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface MRConstructorAnnotation {
	/**
	 * Définit s'il faut aller chercher la description des paramètres dans les
	 * classes mères (par défaut à false)
	 */
	boolean sameParametersAsParent() default false;
	
	/**
	 * Cache un constructeur
	 */
	boolean hide() default false;
}
