package annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Annotation de paramètre de constructeur
 * 
 * @author adrien
 *
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface MRParameterAnnotation {
	/**
	 * Nom du paramètre
	 */
	String name();
	
	/**
	 * Description du paramètre
	 */
	String description();
	
	/**
	 * Valeur par défaut
	 */
	String defaultValue();
}
