package medianRanking;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import utils.Debug;

/**
 * 
 * @author brancotte
 * 
 */
public class KendallTauMergeSortBased implements KendallTauGenerlized {

	// private float p;
	// private float q;

	public KendallTauMergeSortBased() {
		// this(1, 1);
	}

	// /**
	// * @param p
	// * cost when a pair is in the same bucket in one ranking and not
	// * in the same in the other ranking
	// * @param q
	// * cost when two element are not in the gold standard, and in
	// * different bucket in the results
	// */
	// public KendallTauMergeSortBased(float p, float q) {
	// this.p = p;
	// this.q = q;
	// }

	@Override
	public <T> Map<KendallTauType, Float> evaluateResults(List<Collection<T>> elementsR1, List<Collection<T>> elementsR2) {
		int dst = 0;
		Map<KendallTauType, Float> map;

		int id, idB = 1;
		HashMap<T, Integer> mapPos = new HashMap<T, Integer>(elementsR1.size());
		for (Collection<T> bucket : elementsR1) {
			for (T elt : bucket)
				mapPos.put(elt, idB);
			idB++;
		}

		idB = 1;
		id = 0;
		int[][] r2 = new int[mapPos.size()][2];
		int[] ret = new int[3];
		int[][] temp = new int[r2.length][r2[0].length];
		for (Collection<T> bucket : elementsR2) {
			for (T elt : bucket) {
				r2[id][0] = idB;
				r2[id][1] = mapPos.get(elt);
				// r2[id][2] = sizeB++;
				id++;
			}
			idB++;
		}

		// doPQCount(r2, ret, temp, true, false);// useless if no buckets
		doMergeSortCount(r2, ret, 0, r2.length - 1, temp);
		// int oldQp = ret[1];
		// int oldQq = ret[2];
		// ret[1] = ret[2] = 0;
		// doPQCount(r2, ret, temp, false, true);// useless if no buckets

		dst = ret[0];
		// dstP = ret[1];
		// dstQ = ret[2];

		map = new HashMap<KendallTauType, Float>(4);
		map.put(KendallTauType.OriginalKen38, new Float(dst));
		// map.put(KendallTauType.Generalized, dst + p * (dstP + dstQ));
		// map.put(KendallTauType.Asymetric, dst + p * dstP + q * dstQ);
		// float disagree = dst + p * dstP + q * dstQ;
		// map.put(KendallTauType.SimilarityMeasure, (agree - disagree) / (agree
		// + disagree));
		return map;
	}

	@Override
	public <T> Map<KendallTauType, Float> evaluateResults(List<Collection<T>> c, Collection<List<Collection<T>>> inputRankings) {
		int dst = 0;
		// , dstP = 0, dstQ = 0;
		// float agree = 0;
		Map<KendallTauType, Float> map;

		int id = 1, idB = 1;
		HashMap<T, Integer> mapPos = new HashMap<T, Integer>(c.size());
		for (Collection<T> bucket : c) {
			for (T elt : bucket)
				mapPos.put(elt, idB);
			idB++;
		}

		int[][] r2 = new int[mapPos.size()][2];
		int[] ret = new int[3];
		int[][] temp = new int[r2.length][2];
		for (List<Collection<T>> elementsR2 : inputRankings) {
			idB = 1;
			id = 0;
			for (Collection<T> bucket : elementsR2) {
				for (T elt : bucket) {
					r2[id][0] = idB;
					r2[id][1] = mapPos.get(elt);
					id++;
				}
				idB++;
			}

			for (int j = 0; j < ret.length; j++)
				ret[j] = 0;
			// doPQCount(r2, ret, temp, true, false);
			doMergeSortCount(r2, ret, 0, r2.length - 1, temp);
			// int oldQp = ret[1];
			// int oldQq = ret[2];
			// ret[1] = ret[2] = 0;
			// doPQCount(r2, ret, temp, false, true);
			dst += ret[0];
			// dstP += ret[1];
			// dstQ += ret[2];
		}

		map = new HashMap<KendallTauType, Float>(4);
		map.put(KendallTauType.OriginalKen38, new Float(dst));
		// map.put(KendallTauType.Generalized, dst + p * (dstP + dstQ));
		// map.put(KendallTauType.Asymetric, dst + p * dstP + q * dstQ);
		// float disagree = dst + p * dstP + q * dstQ;
		// map.put(KendallTauType.SimilarityMeasure, (agree - disagree) / (agree
		// + disagree));
		return map;
	}

	private void doMergeSortCount(int[][] r2, int[] counts, int start, int end, int[][] temp) {
		if (end <= start)
			return;
		if (Debug.isDebugLevel())
			Debug.debugln("From " + start + " to " + end);
		int mid = (end - start >> 1) + start;
		int left = start;
		int right = mid + 1;
		int i = 0;
		// int pCount = 0, qCount = 0;
		doMergeSortCount(r2, counts, start, mid, temp);
		doMergeSortCount(r2, counts, right, end, temp);

		if (Debug.isDebugLevel()) {
			for (int j = 0; j < temp.length; j++)
				temp[j][0] = temp[j][1] = -1;
			Debug.debugln("From " + start + " to " + end);
		}
		i = start;
		while (right <= end && left <= mid) {
			// if (r2[left][0] != r2[right][0]) {
			if (r2[left][1] < r2[right][1]) {
				// qCount = pCount = 0;
				for (int j = 0; j < temp[i].length; j++)
					temp[i][j] = r2[left][j];
				i++;
				left++;
			} else if (r2[left][1] > r2[right][1]) {
				// qCount = pCount = 0;
				for (int j = 0; j < temp[i].length; j++)
					temp[i][j] = r2[right][j];
				counts[0] += mid - left + 1;// With no bucket it works !
				// for (int j = left; j <= mid; j++)
				// if (r2[right][0] != r2[j][0])
				// counts[0]++;
				i++;
				right++;
			} else {// if (r2[left][1] == r2[right][1]) {
				if (r2[left][0] < r2[right][0]) {
					for (int j = 0; j < temp[i].length; j++)
						temp[i][j] = r2[left][j];
					i++;
					left++;
				} else {
					for (int j = 0; j < temp[i].length; j++)
						temp[i][j] = r2[right][j];
					i++;
					right++;
				}
			}
			// } else {
			// if (r2[left][1] < r2[right][1]) {
			// for (int j = 0; j < temp[i].length; j++)
			// temp[i][j] = r2[left][j];
			// // pCount++;
			// i++;
			// left++;
			// } else if (r2[left][1] > r2[right][1]) {
			// for (int j = 0; j < temp[i].length; j++)
			// temp[i][j] = r2[right][j];
			// for (int j = left; j <= mid; j++)
			// if (r2[right][0] != r2[j][0])
			// counts[0]++;
			// i++;
			// right++;
			// } else {// if (r2[left][1] == r2[right][1]) {
			// for (int j = 0; j < temp[i].length; j++)
			// temp[i][j] = r2[left][j];
			// i++;
			// left++;
			// }
			// }
		}
		while (left <= mid) {
			for (int j = 0; j < temp[i].length; j++)
				temp[i][j] = r2[left][j];
			i++;
			left++;
		}
		while (right <= end) {
			// if (r2[mid][1] == r2[right][1] && r2[mid][0] != r2[right][0])
			// {
			// // counts[2] += qCount;
			// } else if (r2[mid][1] != r2[right][1] && r2[mid][0] ==
			// r2[right][0]) {
			// // counts[1] += pCount;
			// }
			for (int j = 0; j < temp[i].length; j++)
				temp[i][j] = r2[right][j];
			i++;
			right++;
		}
		for (i = start; i <= end; i++) {
			for (int j = 0; j < temp[i].length; j++)
				r2[i][j] = temp[i][j];
		}
	}

	/**
	 * Count the number of pair of elements that are tied/separated in r2
	 * compared to c
	 * 
	 * @param r2
	 * @param counts
	 *            Add of q or p in this array
	 * @param temp
	 * @param doPelseQ
	 *            true if if count the tying of elements, false if i count the
	 *            untying
	 * @param bucketSorted
	 *            are the bucket sorted ? I.e. two elements are tied in one
	 *            ranking they are in the order where they are in the seconde
	 *            ranking
	 */
	protected void doPQCount(int[][] r2, int[] counts, int[][] temp, boolean doPelseQ, boolean bucketSorted) {
		if (!bucketSorted) {
			int start = 0;
			for (int j = 1; j < temp.length; j++) {
				if (r2[j][0] != r2[j - 1][0]) {
					if (start + 1 < j) {
						doMergeSortCount(r2, counts, start, j - 1, temp);
					}
					start = j;
				}
			}
			if (start + 1 < temp.length) {
				doMergeSortCount(r2, counts, start, temp.length - 1, temp);
			}
		}
		int d;
		temp[0][1] = temp[0][0] = 0;
		for (int j = 0; j < temp.length; j++) {
			for (int i = 0; i < 2; i++) {
				if (j == 0 || r2[j][i] != r2[j - 1][i])
					temp[j][i] = 0;
				else
					temp[j][i] = 1 + temp[j - 1][i];
			}
			d = temp[j][0] - temp[j][1];
			if (doPelseQ) {
				if (d > 0)// p
					counts[1] += d;
			} else {
				if (d < 0)// q
					counts[2] -= d;
			}
		}
	}
}
