package medianRanking;

import java.util.Collection;
import java.util.List;

/**
 * 
 * @author Bryan BRANCOTTE
 * 
 * @param <T>
 *            the type of element
 */
public interface MedianRankingWeighted<T> extends MedianRanking<T> {

	/**
	 * 
	 * @param rankings
	 *            the ranking with ties. In the special case where T is a
	 *            Integer, the first element must be 1. This will allow every
	 *            implementation which want to avoid the translation from T to
	 *            int to be sure of the first id. One instead of Zero is
	 *            historical
	 * @return A consensus
	 */
	public List<Collection<T>> computMedianRanking(List<List<Collection<T>>> rankings, List<Double> weights);

	/**
	 * 
	 * 
	 * @param rankings
	 *            the ranking with ties. In the special case where T is a
	 *            Integer, the first element must be 1. This will allow every
	 *            implementation which want to avoid the translation from T to
	 *            int to be sure of the first id. One instead of Zero is
	 *            historical
	 * @return One or more consensus if the underlying algorithm can find
	 *         multiple solution as good one another. If the implemeting
	 *         algorithm is not able to provide multiple consensus, it should
	 *         return a collection made of the only one consensus found
	 */
	public Collection<List<Collection<T>>> computMedianRankings(List<List<Collection<T>>> rankings, List<Double> weights);
}
