package medianRanking;

import java.util.Collection;
import java.util.List;

import utils.Wrappers;

/**
 * 
 * @author Bryan BRANCOTTE
 * 
 */
public class MockMedianRanking<T> implements MedianRanking<T> {

	private List<Collection<T>> ranking;

	public MockMedianRanking() {
	}

	public MockMedianRanking(List<Collection<T>> ranking) {
		this.ranking = ranking;
	}

	@Override
	public List<Collection<T>> computMedianRanking(Collection<List<Collection<T>>> rankings) {
		if (ranking == null)
			return rankings.iterator().next();
		return ranking;
	}

	@Override
	public String getFullName() {
		return "MockMedianRanking";
	}

	@Override
	public boolean isBreakingTiesArbitrarily() {
		return false;
	}

	@Override
	public boolean isUsingRandomValue() {
		return false;
	}

	@Override
	public Collection<List<Collection<T>>> computMedianRankings(Collection<List<Collection<T>>> rankings) {
		return Wrappers.wrapInCollection(computMedianRanking(rankings));
	}

}
