package medianRanking;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import medianRanking.KendallTauGenerlized.KendallTauType;

/**
 * 
 * @author brancotte
 * 
 */
public class SimilarityMeasure {

	public static enum SimilarityMeasureType {
		MedianSimilarityMeasure("Median(SimilarityMeasure)"), MeanSimilarityMeasure("Mean(SimilarityMeasure)");

		private String name;

		private SimilarityMeasureType(String name) {
			this.name = name;
		}

		public String getName() {
			return name;
		}
	}

	public <T> Map<SimilarityMeasureType, Float> computeSimilarities(KendallTauGenerlized ktg, List<List<Collection<T>>> rankings) {
		Vector<Float> similarityMeasures = new Vector<Float>();
		for (int i = 0; i < rankings.size(); i++) {
			for (int j = i + 1; j < rankings.size(); j++) {
				similarityMeasures.add(ktg.evaluateResults(rankings.get(i), rankings.get(j)).get(KendallTauType.SimilarityMeasure));
			}
		}
		Map<SimilarityMeasureType, Float> map;
		map = new HashMap<SimilarityMeasureType, Float>(2);
		map.put(SimilarityMeasureType.MeanSimilarityMeasure, (float) (Statistics.mean(similarityMeasures)));
		map.put(SimilarityMeasureType.MedianSimilarityMeasure, (float) (Statistics.median(similarityMeasures)));
		return map;
	}

}
